Skip to content

List Directory Files

FileListPageResponse Beta.Directories.Files.List(FileListParamsparameters, CancellationTokencancellationToken = default)
GET/api/v1/beta/directories/{directory_id}/files

List all files within the specified directory with optional filtering and pagination.

ParametersExpand Collapse
FileListParams parameters
required string directoryID
string? displayName
string? displayNameContains
IReadOnlyList<string>? expand

Fields to expand on each directory file.

string? fileID
Boolean includeDeleted
string? organizationID
Long? pageSize
string? pageToken
string? projectID
string? uniqueID
DateTimeOffset? updatedAtOnOrAfter

Include items updated at or after this timestamp (inclusive)

formatdate-time
DateTimeOffset? updatedAtOnOrBefore

Include items updated at or before this timestamp (inclusive)

formatdate-time
ReturnsExpand Collapse
class FileListPageResponse:

API query response schema for directory files.

required IReadOnlyList<FileListResponse> Items

The list of items.

required string ID

Unique identifier for the directory file.

required string DirectoryID

Directory the file belongs to.

required string DisplayName

Display name for the file.

minLength1
required string ProjectID

Project the directory file belongs to.

required string UniqueID

Unique identifier for the file in the directory

minLength1
DateTimeOffset? CreatedAt

Creation datetime

formatdate-time
DateTimeOffset? DeletedAt

Soft delete marker when the file is removed upstream or by user action.

formatdate-time
PresignedUrl? DownloadUrl

Schema for a presigned URL.

required DateTimeOffset ExpiresAt

The time at which the presigned URL expires

formatdate-time
required string Url

A presigned URL for IO operations against a private file

formaturi
minLength1
IReadOnlyDictionary<string, string>? FormFields

Form fields for a presigned POST request

string? FileID

File ID for the storage location.

IReadOnlyDictionary<string, Metadata> Metadata

Merged metadata from all sources. Higher-priority sources override lower.

One of the following:
string
Long
Double
Boolean
JsonElement
IReadOnlyList<string>
DateTimeOffset? UpdatedAt

Update datetime

formatdate-time
string? NextPageToken

A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

Long? TotalSize

The total number of items available. This is only populated when specifically requested. The value may be an estimate and can be used for display purposes only.

List Directory Files

FileListParams parameters = new() { DirectoryID = "directory_id" };

var page = await client.Beta.Directories.Files.List(parameters);
await foreach (var item in page.Paginate())
{
    Console.WriteLine(item);
}
{
  "items": [
    {
      "id": "id",
      "directory_id": "directory_id",
      "display_name": "x",
      "project_id": "project_id",
      "unique_id": "x",
      "created_at": "2019-12-27T18:11:19.117Z",
      "deleted_at": "2019-12-27T18:11:19.117Z",
      "download_url": {
        "expires_at": "2019-12-27T18:11:19.117Z",
        "url": "https://example.com",
        "form_fields": {
          "foo": "string"
        }
      },
      "file_id": "file_id",
      "metadata": {
        "foo": "string"
      },
      "updated_at": "2019-12-27T18:11:19.117Z"
    }
  ],
  "next_page_token": "next_page_token",
  "total_size": 0
}
Returns Examples
{
  "items": [
    {
      "id": "id",
      "directory_id": "directory_id",
      "display_name": "x",
      "project_id": "project_id",
      "unique_id": "x",
      "created_at": "2019-12-27T18:11:19.117Z",
      "deleted_at": "2019-12-27T18:11:19.117Z",
      "download_url": {
        "expires_at": "2019-12-27T18:11:19.117Z",
        "url": "https://example.com",
        "form_fields": {
          "foo": "string"
        }
      },
      "file_id": "file_id",
      "metadata": {
        "foo": "string"
      },
      "updated_at": "2019-12-27T18:11:19.117Z"
    }
  ],
  "next_page_token": "next_page_token",
  "total_size": 0
}
Note for AI agents: this documentation is built for programmatic access. - Overview of all docs: https://developers.llamaindex.ai/llms.txt - Any page is available as raw Markdown by appending index.md to its URL — e.g. https://developers.llamaindex.ai/llamaparse/parse/getting_started/index.md - Agent-friendly REST search APIs live under https://developers.llamaindex.ai/api/ — search (BM25 full-text), grep (regex), read (fetch a page), and list (browse the doc tree). See https://developers.llamaindex.ai/llms.txt for parameters. - A hosted documentation MCP server is available at https://developers.llamaindex.ai/mcp. If you support MCP, you can ask the user to install it for browsing these docs directly (an alternative to the REST API). Setup: https://developers.llamaindex.ai/for-agents/mcp/ - Other LlamaIndex tooling for agents — the LlamaParse Platform MCP server, agent skills and plugins, and the n8n node — is mapped at https://developers.llamaindex.ai/for-agents/